GNU bug report logs - #29170
Emacs freezes when capturing an org-template (multiple calls to gui-get-selection))

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: daimrod@HIDDEN (Grégoire Jadi); dated Mon, 6 Nov 2017 14:22:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Changed bug title to 'Emacs freezes when capturing an org-template (multiple calls to gui-get-selection))' from '26.0.90; Emacs freezes when capturing an org-template' Request was from Noam Postavsky <npostavs@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 29170 <at> debbugs.gnu.org:


Received: (at 29170) by debbugs.gnu.org; 22 Nov 2017 15:00:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 22 10:00:19 2017
Received: from localhost ([127.0.0.1]:52828 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eHWVf-0006ev-GC
	for submit <at> debbugs.gnu.org; Wed, 22 Nov 2017 10:00:19 -0500
Received: from ledu-giraud.fr ([195.154.162.172]:36306)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <manuel@HIDDEN>) id 1eHWVd-0006en-Pu
 for 29170 <at> debbugs.gnu.org; Wed, 22 Nov 2017 10:00:18 -0500
Received: from elite.giraud (10.1.1.1 [10.1.1.1])
 by ledu-giraud.fr (OpenSMTPD) with ESMTPSA id 40b1fdcb
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256:NO); 
 Wed, 22 Nov 2017 16:00:16 +0100 (CET)
From: Manuel Giraud <manuel@HIDDEN>
To: daimrod@HIDDEN (=?utf-8?Q?Gr=C3=A9goire?= Jadi)
Subject: Re: bug#29170: Infinite loop noticed on Emacs in OpenBSD
References: <87fu9rwksm.fsf@HIDDEN> <87fu9n7aq9.fsf@HIDDEN>
 <87bmk17z18.fsf@HIDDEN> <877eui4blp.fsf@HIDDEN>
 <87o9nujrjt.fsf@HIDDEN>
Date: Wed, 22 Nov 2017 16:00:15 +0100
In-Reply-To: <87o9nujrjt.fsf@HIDDEN> (=?utf-8?Q?=22Gr=C3=A9goire?=
 Jadi"'s message of "Wed, 22 Nov 2017 15:50:46 +0100")
Message-ID: <87wp2i2wao.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.0.90 (berkeley-unix)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 29170
Cc: 29170 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

daimrod@HIDDEN (Gr=C3=A9goire Jadi) writes:

> I agree with you. I saw this discussion too, though I don't understand
> most of it. I blindly tried the patches to see if it fixed the problem
> but it did not.

I've just tried it too and get to the same conclusion :-)
--=20
Manuel Giraud




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29170; Package emacs. Full text available.

Message received at 29170 <at> debbugs.gnu.org:


Received: (at 29170) by debbugs.gnu.org; 22 Nov 2017 14:50:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 22 09:50:56 2017
Received: from localhost ([127.0.0.1]:52012 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eHWMa-0006E5-JR
	for submit <at> debbugs.gnu.org; Wed, 22 Nov 2017 09:50:56 -0500
Received: from a.omecha.info ([89.234.176.136]:38680 helo=omecha.info)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <daimrod@HIDDEN>) id 1eHWMY-0006Dq-40
 for 29170 <at> debbugs.gnu.org; Wed, 22 Nov 2017 09:50:54 -0500
Received: from puffy.omecha.info (unknown [192.168.99.18])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 by omecha.info (Postfix) with ESMTPSA id 09CADA7;
 Wed, 22 Nov 2017 15:50:47 +0100 (CET)
From: daimrod@HIDDEN (=?utf-8?Q?Gr=C3=A9goire?= Jadi)
To: Manuel Giraud <manuel@HIDDEN>
Subject: Re: bug#29170: Infinite loop noticed on Emacs in OpenBSD
References: <87fu9rwksm.fsf@HIDDEN> <87fu9n7aq9.fsf@HIDDEN>
 <87bmk17z18.fsf@HIDDEN> <877eui4blp.fsf@HIDDEN>
Date: Wed, 22 Nov 2017 15:50:46 +0100
In-Reply-To: <877eui4blp.fsf@HIDDEN> (Manuel Giraud's message of "Wed,
 22 Nov 2017 15:44:18 +0100")
Message-ID: <87o9nujrjt.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (berkeley-unix)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 29170
Cc: 29170 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Manuel Giraud <manuel@HIDDEN> writes:

> daimrod@HIDDEN (Gr=C3=A9goire Jadi) writes:
>
>> Manuel Giraud <manuel@HIDDEN> writes:
>>
>>> Hi,
>>
>> Hello Manuel,
>>
>> Thanks for the reply and sorry for the delay.
>
> Same :-)
>
>>> Here is a patch against HEAD to avoid the hang in infinite loop. The
>>> 'x-selection-timeout' pause will still be there even with this patch.
>>
>> I've tested your patch on emacs-25-3.1 and it does prevent the infinite
>> loop. However, if the user sends input to emacs while it is waiting, it
>> raises the following backtrace :
>
> Ok. There seems to be ongoing work on wait_reading_process_output:
> https://lists.gnu.org/archive/html/emacs-devel/2017-11/threads.html#00037
>
> So it might be urgent to wait and see what happens on OpenBSD after this
> work is done. What you think?

I agree with you. I saw this discussion too, though I don't understand
most of it. I blindly tried the patches to see if it fixed the problem
but it did not.

Maybe someone will look at this bug once its merged.
So, let's wait :)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29170; Package emacs. Full text available.

Message received at 29170 <at> debbugs.gnu.org:


Received: (at 29170) by debbugs.gnu.org; 22 Nov 2017 14:44:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 22 09:44:23 2017
Received: from localhost ([127.0.0.1]:51997 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eHWGF-00063u-5y
	for submit <at> debbugs.gnu.org; Wed, 22 Nov 2017 09:44:23 -0500
Received: from ledu-giraud.fr ([195.154.162.172]:6836)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <manuel@HIDDEN>) id 1eHWGC-00063k-P8
 for 29170 <at> debbugs.gnu.org; Wed, 22 Nov 2017 09:44:21 -0500
Received: from elite.giraud (10.1.1.1 [10.1.1.1])
 by ledu-giraud.fr (OpenSMTPD) with ESMTPSA id 8dd3eaa5
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256:NO); 
 Wed, 22 Nov 2017 15:44:19 +0100 (CET)
From: Manuel Giraud <manuel@HIDDEN>
To: daimrod@HIDDEN (=?utf-8?Q?Gr=C3=A9goire?= Jadi)
Subject: Re: bug#29170: Infinite loop noticed on Emacs in OpenBSD
References: <87fu9rwksm.fsf@HIDDEN> <87fu9n7aq9.fsf@HIDDEN>
 <87bmk17z18.fsf@HIDDEN>
Date: Wed, 22 Nov 2017 15:44:18 +0100
In-Reply-To: <87bmk17z18.fsf@HIDDEN> (=?utf-8?Q?=22Gr=C3=A9goire?=
 Jadi"'s message of "Fri, 17 Nov 2017 15:36:19 +0100")
Message-ID: <877eui4blp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.0.90 (berkeley-unix)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 29170
Cc: 29170 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

daimrod@HIDDEN (Gr=C3=A9goire Jadi) writes:

> Manuel Giraud <manuel@HIDDEN> writes:
>
>> Hi,
>
> Hello Manuel,
>
> Thanks for the reply and sorry for the delay.

Same :-)

>> Here is a patch against HEAD to avoid the hang in infinite loop. The
>> 'x-selection-timeout' pause will still be there even with this patch.
>
> I've tested your patch on emacs-25-3.1 and it does prevent the infinite
> loop. However, if the user sends input to emacs while it is waiting, it
> raises the following backtrace :

Ok. There seems to be ongoing work on wait_reading_process_output:
https://lists.gnu.org/archive/html/emacs-devel/2017-11/threads.html#00037

So it might be urgent to wait and see what happens on OpenBSD after this
work is done. What you think?
--=20
Manuel Giraud




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29170; Package emacs. Full text available.

Message received at 29170 <at> debbugs.gnu.org:


Received: (at 29170) by debbugs.gnu.org; 17 Nov 2017 14:36:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 17 09:36:29 2017
Received: from localhost ([127.0.0.1]:44418 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eFhkr-0000QM-JR
	for submit <at> debbugs.gnu.org; Fri, 17 Nov 2017 09:36:29 -0500
Received: from a.omecha.info ([89.234.176.136]:38134 helo=omecha.info)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <daimrod@HIDDEN>) id 1eFhkp-0000Q3-KU
 for 29170 <at> debbugs.gnu.org; Fri, 17 Nov 2017 09:36:28 -0500
Received: from puffy.omecha.info (unknown [192.168.99.18])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 by omecha.info (Postfix) with ESMTPSA id 4ED24590;
 Fri, 17 Nov 2017 15:36:20 +0100 (CET)
From: daimrod@HIDDEN (=?utf-8?Q?Gr=C3=A9goire?= Jadi)
To: Manuel Giraud <manuel@HIDDEN>
Subject: Re: bug#29170: Infinite loop noticed on Emacs in OpenBSD
References: <87fu9rwksm.fsf@HIDDEN> <87fu9n7aq9.fsf@HIDDEN>
Date: Fri, 17 Nov 2017 15:36:19 +0100
Message-ID: <87bmk17z18.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (berkeley-unix)
MIME-Version: 1.0
Content-Type: text/plain
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 29170
Cc: 29170 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Manuel Giraud <manuel@HIDDEN> writes:

> Hi,

Hello Manuel,

Thanks for the reply and sorry for the delay.

> Here is a patch against HEAD to avoid the hang in infinite loop. The
> 'x-selection-timeout' pause will still be there even with this patch.

I've tested your patch on emacs-25-3.1 and it does prevent the infinite
loop. However, if the user sends input to emacs while it is waiting, it
raises the following backtrace :

Debugger entered--Lisp error: (error "Timed out waiting for reply from selection owner")
  x-get-selection-internal(SECONDARY STRING nil nil)
  #[1026 "\300$\207" [x-get-selection-internal] 9 "\n\n(fn SELECTION-SYMBOL TARGET-TYPE &optional TIME-STAMP TERMINAL)"](SECONDARY STRING)
  apply(#[1026 "\300$\207" [x-get-selection-internal] 9 "\n\n(fn SELECTION-SYMBOL TARGET-TYPE &optional TIME-STAMP TERMINAL)"] (SECONDARY STRING))
  gui-backend-get-selection(SECONDARY STRING)
  gui-get-selection(SECONDARY STRING)
  (let ((value (quote SECONDARY)) (x-selection-timeout 2000)) (gui-get-selection value (quote UTF8_STRING)) (gui-get-selection value (quote COMPOUND_TEXT)) (gui-get-selection value (quote STRING)) (gui-get-selection value (quote TEXT)))
  eval((let ((value (quote SECONDARY)) (x-selection-timeout 2000)) (gui-get-selection value (quote UTF8_STRING)) (gui-get-selection value (quote COMPOUND_TEXT)) (gui-get-selection value (quote STRING)) (gui-get-selection value (quote TEXT))) nil)
  elisp--eval-last-sexp(nil)
  eval-last-sexp(nil)
  funcall-interactively(eval-last-sexp nil)
  call-interactively(eval-last-sexp nil nil)
  command-execute(eval-last-sexp)

But it's still better than a complete freeze IMO.

> My understandings:
>
> On OpenBSD, most of the time, the function
> "xselect.c/x_get_foreign_selection" won't get a SelectNotify with
> (SECONDARY, TEXT) as arguments (that I did not understand and it might
> never happen on other oses).
>
> But then, while waiting at most 'x-selection-timeout' into
> "process.c/wait_reading_process_output" the 'now' variable won't have a
> chance of being invalidated or updated and that is what cause the
> infinite loop.
>
> Someone more knowledgeable of "process.c/wait_reading_process_output"
> might have a better solution to this problem.
>
> diff --git a/src/process.c b/src/process.c
> index fc46e74332..25bd28a82b 100644
> --- a/src/process.c
> +++ b/src/process.c
> @@ -5115,8 +5115,7 @@ wait_reading_process_output (intmax_t time_limit, int nsecs, int read_kbd,
>        /* Exit if already run out.  */
>        if (wait == TIMEOUT)
>  	{
> -	  if (!timespec_valid_p (now))
> -	    now = current_timespec ();
> +	  now = current_timespec ();
>  	  if (timespec_cmp (end_time, now) <= 0)
>  	    break;
>  	  timeout = timespec_sub (end_time, now);




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29170; Package emacs. Full text available.

Message received at 29170 <at> debbugs.gnu.org:


Received: (at 29170) by debbugs.gnu.org; 9 Nov 2017 15:06:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 09 10:06:25 2017
Received: from localhost ([127.0.0.1]:60541 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eCoPR-0004ez-Ff
	for submit <at> debbugs.gnu.org; Thu, 09 Nov 2017 10:06:25 -0500
Received: from ledu-giraud.fr ([195.154.162.172]:3692)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <manuel@HIDDEN>) id 1eCoPP-0004eq-KZ
 for 29170 <at> debbugs.gnu.org; Thu, 09 Nov 2017 10:06:24 -0500
Received: from elite.giraud (10.1.1.1 [10.1.1.1])
 by ledu-giraud.fr (OpenSMTPD) with ESMTPSA id 2341183a
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256:NO)
 for <29170 <at> debbugs.gnu.org>; Thu, 9 Nov 2017 16:06:22 +0100 (CET)
From: Manuel Giraud <manuel@HIDDEN>
To: 29170 <at> debbugs.gnu.org
Subject: Infinite loop noticed on Emacs in OpenBSD
Date: Thu, 09 Nov 2017 16:06:22 +0100
Message-ID: <87fu9n7aq9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.0.90 (berkeley-unix)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 29170
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Hi,

Here is a patch against HEAD to avoid the hang in infinite loop. The
'x-selection-timeout' pause will still be there even with this patch.

My understandings:

On OpenBSD, most of the time, the function
"xselect.c/x_get_foreign_selection" won't get a SelectNotify with
(SECONDARY, TEXT) as arguments (that I did not understand and it might
never happen on other oses).

But then, while waiting at most 'x-selection-timeout' into
"process.c/wait_reading_process_output" the 'now' variable won't have a
chance of being invalidated or updated and that is what cause the
infinite loop.

Someone more knowledgeable of "process.c/wait_reading_process_output"
might have a better solution to this problem.

diff --git a/src/process.c b/src/process.c
index fc46e74332..25bd28a82b 100644
--- a/src/process.c
+++ b/src/process.c
@@ -5115,8 +5115,7 @@ wait_reading_process_output (intmax_t time_limit, int nsecs, int read_kbd,
       /* Exit if already run out.  */
       if (wait == TIMEOUT)
 	{
-	  if (!timespec_valid_p (now))
-	    now = current_timespec ();
+	  now = current_timespec ();
 	  if (timespec_cmp (end_time, now) <= 0)
 	    break;
 	  timeout = timespec_sub (end_time, now);
-- 
Manuel Giraud




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29170; Package emacs. Full text available.

Message received at 29170 <at> debbugs.gnu.org:


Received: (at 29170) by debbugs.gnu.org; 8 Nov 2017 18:21:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 08 13:21:24 2017
Received: from localhost ([127.0.0.1]:58861 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eCUyZ-00085v-IL
	for submit <at> debbugs.gnu.org; Wed, 08 Nov 2017 13:21:24 -0500
Received: from emma.ex.com.pl ([94.23.12.177]:38826)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pki@HIDDEN>) id 1eCUeh-0007a0-7D
 for 29170 <at> debbugs.gnu.org; Wed, 08 Nov 2017 13:00:51 -0500
Received: from [192.168.0.14] (helo=undefined)
 by emma.ex.com.pl with esmtpsa (TLSv1.2:DHE-RSA-AES256-GCM-SHA384:256)
 (Exim 4.85) (envelope-from <pki@HIDDEN>) id 1eCUeZ-0006M7-Dp
 for 29170 <at> debbugs.gnu.org; Wed, 08 Nov 2017 19:00:43 +0100
Received: from pki by undefined with local (Exim 4.89)
 (envelope-from <pki@HIDDEN>) id 1eCUeY-0000mm-DK
 for 29170 <at> debbugs.gnu.org; Wed, 08 Nov 2017 19:00:42 +0100
Date: Wed, 8 Nov 2017 19:00:42 +0100
From: Piotr Isajew <pki@HIDDEN>
To: 29170 <at> debbugs.gnu.org
Subject: Infinite loop noticed on Emacs in OpenBSD
Message-ID: <20171108180042.GA25530@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
X-No-Archive: Yes
X-PGP-Key: 0x481BC5D8
User-Agent: Mutt/1.9.1 (2017-09-22)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 29170
X-Mailman-Approved-At: Wed, 08 Nov 2017 13:21:20 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Adding to the original report - I've noticed an issue which may
also relate to the same problem.

I'm using org-capture on OpenBSD under X11. M-x org-capture
displays a list of capture templates. On any other system I have
access to, or even on OpenBSD console, pressing a template letter
will open a capture buffer. On X11 however it hangs until I move
mouse. This was observed for Emacs 25 and 26 on OpenBSD
only. Additionally there are some situations when Emacs will just
hang in an infinite loop. There's no way to interrupt this, other
than SIGKILL.

I'm attaching stacktraces for such a situation:

info thre
  4 thread 424274  _thread_sys_poll () at -:3
  3 thread 437321  _thread_sys_poll () at -:3
* 2 thread 476142  _thread_sys_poll () at -:3
  1 thread 131181  wait_reading_process_output (time_limit=5, nsecs=0, 
    read_kbd=0, do_display=false, wait_for_cell=16374659, wait_proc=0x0, 
    just_wait_proc=0) at process.c:5296
(gdb) thr 4
[Switching to thread 4 (thread 424274)]#0  _thread_sys_poll () at -:3
3       in -
(gdb) inf sta
#0  _thread_sys_poll () at -:3
#1  0x00000002c6d1f45f in _libc_poll_cancel (fds=Variable "fds" is not available.
)
    at /usr/src/lib/libc/sys/w_poll.c:27
#2  0x000000022d883497 in g_main_context_iterate () at gmain.c:4271
#3  0x000000022d883594 in g_main_context_iteration (context=0x20ddb0500, 
    may_block=The value of variable 'may_block' is distributed across several
locations, and GDB cannot access its value.

) at gmain.c:4033
#4  0x00000002c7f2bb7d in g_io_module_query ()
   from /usr/local/lib/gio/modules/libdconfsettings.so
#5  0x000000022d8ac3fa in g_thread_proxy (data=0x259d50190) at gthread.c:784
#6  0x0000000275642cae in _rthread_start (v=Variable "v" is not available.
)
    at /usr/src/lib/librthread/rthread.c:96
#7  0x00000002c6d1b96b in __tfork_thread ()
    at /usr/src/lib/libc/arch/amd64/sys/tfork_thread.S:75
#8  0x0000000000000000 in ?? ()

(gdb) thr 3
[Switching to thread 3 (thread 437321)]#0  _thread_sys_poll () at -:3
3       in -
(gdb) inf sta
#0  _thread_sys_poll () at -:3
#1  0x00000002c6d1f45f in _libc_poll_cancel (fds=Variable "fds" is not available.
)
    at /usr/src/lib/libc/sys/w_poll.c:27
#2  0x000000022d883497 in g_main_context_iterate () at gmain.c:4271
#3  0x000000022d883594 in g_main_context_iteration (context=0x243a3ce00, 
    may_block=The value of variable 'may_block' is distributed across several
locations, and GDB cannot access its value.

) at gmain.c:4033
#4  0x000000022d885296 in glib_worker_main (data=Variable "data" is not available.
) at gmain.c:5824
#5  0x000000022d8ac3fa in g_thread_proxy (data=0x259d50000) at gthread.c:784
#6  0x0000000275642cae in _rthread_start (v=Variable "v" is not available.
)
    at /usr/src/lib/librthread/rthread.c:96
#7  0x00000002c6d1b96b in __tfork_thread ()
    at /usr/src/lib/libc/arch/amd64/sys/tfork_thread.S:75

(gdb) thr 2
[Switching to thread 2 (thread 476142)]#0  _thread_sys_poll () at -:3
3       in -
(gdb) inf sta
#0  _thread_sys_poll () at -:3
#1  0x00000002c6d1f45f in _libc_poll_cancel (fds=Variable "fds" is not available.
)
    at /usr/src/lib/libc/sys/w_poll.c:27
#2  0x000000022d883497 in g_main_context_iterate () at gmain.c:4271
#3  0x000000022d88382f in g_main_loop_run (loop=0x249a70a80) at gmain.c:4168
#4  0x00000002a5dac8cb in gdbus_shared_thread_func (user_data=0x2039baa80)
    at gdbusprivate.c:252
#5  0x000000022d8ac3fa in g_thread_proxy (data=0x27f39fed0) at gthread.c:784
#6  0x0000000275642cae in _rthread_start (v=Variable "v" is not available.
)
    at /usr/src/lib/librthread/rthread.c:96
#7  0x00000002c6d1b96b in __tfork_thread ()
    at /usr/src/lib/libc/arch/amd64/sys/tfork_thread.S:75
#8  0x0000000000000000 in ?? ()


(gdb) thr 1
[Switching to thread 1 (thread 131181)]#0  wait_reading_process_output (
    time_limit=5, nsecs=0, read_kbd=0, do_display=false, 
    wait_for_cell=16374659, wait_proc=0x0, just_wait_proc=0) at process.c:5296
5296              FD_ZERO (&Available);
Current language:  auto; currently minimal
(gdb) inf sta
#0  wait_reading_process_output (time_limit=5, nsecs=0, read_kbd=0, 
    do_display=false, wait_for_cell=16374659, wait_proc=0x0, just_wait_proc=0)
    at process.c:5296
#1  0x00000000005b297d in x_get_foreign_selection (selection_symbol=9120, 
    target_type=240, time_stamp=0, frame=22101045) at xselect.c:1201
#2  0x00000000005b1f4c in Fx_get_selection_internal (selection_symbol=9120, 
    target_type=240, time_stamp=0, terminal=0) at xselect.c:2010
#3  0x00000000006fabf7 in funcall_subr (subr=0xbc8318, numargs=4, 
    args=0x7f7ffffdacd0) at eval.c:2849
#4  0x00000000006f983a in Ffuncall (nargs=5, args=0x7f7ffffdacc8)
    at eval.c:2766
#5  0x0000000000782f3d in exec_byte_code (bytestr=26624420, vector=20306061, 
    maxdepth=38, args_template=4106, nargs=2, args=0x7f7ffffdb798)
    at bytecode.c:629
#6  0x00000000006fafc5 in funcall_lambda (fun=23387365, nargs=2, 
    arg_vector=0x7f7ffffdb788) at eval.c:2967
#7  0x00000000006f9882 in Ffuncall (nargs=3, args=0x7f7ffffdb780)
    at eval.c:2768
#8  0x00000000006f961a in Fapply (nargs=2, args=0x7f7ffffdc0f0) at eval.c:2386
#9  0x00000000006faa86 in funcall_subr (subr=0xed78d8, numargs=2, 
    args=0x7f7ffffdc0f0) at eval.c:2821
#10 0x00000000006f983a in Ffuncall (nargs=3, args=0x7f7ffffdc0e8)
    at eval.c:2766
#11 0x0000000000782f3d in exec_byte_code (bytestr=22680196, vector=21880661, 
    maxdepth=62, args_template=514, nargs=2, args=0x7f7ffffdcc20)
    at bytecode.c:629
#12 0x00000000006fafc5 in funcall_lambda (fun=21811109, nargs=2, 
    arg_vector=0x7f7ffffdcc20) at eval.c:2967
#13 0x00000000006f9882 in Ffuncall (nargs=3, args=0x7f7ffffdcc18)
    at eval.c:2768
#14 0x0000000000782f3d in exec_byte_code (bytestr=13593108, vector=13593141, 
    maxdepth=38, args_template=2050, nargs=2, args=0x7f7ffffdd758)
    at bytecode.c:629
#15 0x00000000006fafc5 in funcall_lambda (fun=13593061, nargs=2, 
    arg_vector=0x7f7ffffdd748) at eval.c:2967
#16 0x00000000006f9882 in Ffuncall (nargs=3, args=0x7f7ffffdd740)
    at eval.c:2768
#17 0x0000000000782f3d in exec_byte_code (bytestr=11746807908, 
    vector=24821037, maxdepth=34, args_template=1030, nargs=1, 
    args=0x7f7ffffde348) at bytecode.c:629
#18 0x00000000006fafc5 in funcall_lambda (fun=24821173, nargs=1, 
    arg_vector=0x7f7ffffde340) at eval.c:2967
#19 0x00000000006f9882 in Ffuncall (nargs=2, args=0x7f7ffffde338)
    at eval.c:2768
#20 0x0000000000782f3d in exec_byte_code (bytestr=11743124740, 
    vector=11965495141, maxdepth=178, args_template=3074, nargs=0, 
    args=0x7f7ffffdf3e0) at bytecode.c:629
#21 0x00000000006fafc5 in funcall_lambda (fun=11965496357, nargs=0, 
    arg_vector=0x7f7ffffdf3e0) at eval.c:2967
#22 0x00000000006f9882 in Ffuncall (nargs=1, args=0x7f7ffffdf3d8)
    at eval.c:2768
#23 0x0000000000782f3d in exec_byte_code (bytestr=11904366884, 
    vector=9575961797, maxdepth=86, args_template=2050, nargs=1, 
    args=0x7f7ffffe01f8) at bytecode.c:629
#24 0x00000000006fafc5 in funcall_lambda (fun=9575962493, nargs=1, 
    arg_vector=0x7f7ffffe01f0) at eval.c:2967
#25 0x00000000006f9882 in Ffuncall (nargs=2, args=0x7f7ffffe01e8)
    at eval.c:2768
#26 0x00000000006daa3a in Ffuncall_interactively (nargs=2, args=0x7f7ffffe01e8)
    at callint.c:252
#27 0x00000000006faa86 in funcall_subr (subr=0xed7308, numargs=2, 
    args=0x7f7ffffe01e8) at eval.c:2821
#28 0x00000000006f983a in Ffuncall (nargs=3, args=0x7f7ffffe01e0)
    at eval.c:2766
#29 0x00000000006dd2bb in Fcall_interactively (function=7336368, 
    record_flag=0, keys=10242735877) at callint.c:841
#30 0x00000000006fabb9 in funcall_subr (subr=0xed72d8, numargs=3, 
    args=0x7f7ffffe0a20) at eval.c:2846
#31 0x00000000006f983a in Ffuncall (nargs=4, args=0x7f7ffffe0a18)
    at eval.c:2766
#32 0x0000000000782f3d in exec_byte_code (bytestr=13161172, vector=13161205, 
    maxdepth=54, args_template=4102, nargs=1, args=0x7f7ffffe15a8)
    at bytecode.c:629
#33 0x00000000006fafc5 in funcall_lambda (fun=13161125, nargs=1, 
    arg_vector=0x7f7ffffe15a0) at eval.c:2967
#34 0x00000000006f9882 in Ffuncall (nargs=2, args=0x7f7ffffe1598)
    at eval.c:2768
#35 0x00000000006fa3b2 in call1 (fn=15840, arg1=7336368) at eval.c:2617
#36 0x00000000005d67d7 in command_loop_1 () at keyboard.c:1482
#37 0x00000000006eaa57 in internal_condition_case (
    bfun=0x5d5e50 <command_loop_1>, handlers=20688, hfun=0x5ec220 <cmd_error>)
    at eval.c:1332
#38 0x00000000005ec122 in command_loop_2 (ignore=0) at keyboard.c:1110
#39 0x00000000006ea218 in internal_catch (tag=50256, 
    func=0x5ec0f0 <command_loop_2>, arg=0) at eval.c:1097
#40 0x00000000005d5414 in command_loop () at keyboard.c:1089
#41 0x00000000005d527c in recursive_edit_1 () at keyboard.c:695
#42 0x00000000005d559e in Frecursive_edit () at keyboard.c:766
#43 0x00000000005d301f in main (argc=1, argv=0x7f7ffffe1d78) at emacs.c:1713




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29170; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 6 Nov 2017 14:21:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 06 09:21:09 2017
Received: from localhost ([127.0.0.1]:53169 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eBiGy-0007sH-Q7
	for submit <at> debbugs.gnu.org; Mon, 06 Nov 2017 09:21:09 -0500
Received: from eggs.gnu.org ([208.118.235.92]:40625)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <daimrod@HIDDEN>) id 1eBiGw-0007rP-E4
 for submit <at> debbugs.gnu.org; Mon, 06 Nov 2017 09:21:06 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <daimrod@HIDDEN>) id 1eBiGl-0005mh-34
 for submit <at> debbugs.gnu.org; Mon, 06 Nov 2017 09:21:01 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.0 required=5.0 tests=BAYES_40 autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:33013)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <daimrod@HIDDEN>) id 1eBiGl-0005mK-0C
 for submit <at> debbugs.gnu.org; Mon, 06 Nov 2017 09:20:55 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:59726)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <daimrod@HIDDEN>) id 1eBiGg-0004vG-Kv
 for bug-gnu-emacs@HIDDEN; Mon, 06 Nov 2017 09:20:54 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <daimrod@HIDDEN>) id 1eBiGa-0005V3-Qa
 for bug-gnu-emacs@HIDDEN; Mon, 06 Nov 2017 09:20:50 -0500
Received: from a.omecha.info ([89.234.176.136]:33752 helo=omecha.info)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <daimrod@HIDDEN>) id 1eBiGa-0005Th-Jn
 for bug-gnu-emacs@HIDDEN; Mon, 06 Nov 2017 09:20:44 -0500
Received: from puffy.omecha.info (unknown [192.168.99.18])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 by omecha.info (Postfix) with ESMTPSA id 6695A1EF
 for <bug-gnu-emacs@HIDDEN>; Mon,  6 Nov 2017 15:20:42 +0100 (CET)
From: daimrod@HIDDEN (=?utf-8?Q?Gr=C3=A9goire?= Jadi)
To: bug-gnu-emacs@HIDDEN
Subject: 26.0.90; Emacs freezes when capturing an org-template
Date: Mon, 06 Nov 2017 15:20:41 +0100
Message-ID: <87fu9rwksm.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.1 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.1 (----)


Hello,

For some time now (emacs-25.1), emacs freezes when I use `org-capture'.
The problem occurs when emacs tries to read the SECONDARY selection.

The following snippet can be used to freeze emacs for 2s everytime on my
computer :
(let ((value 'SECONDARY)
      (x-selection-timeout 2000))
  ;;; from org-get-x-clipboard in lisp/org-compat.el
  (gui-get-selection value 'UTF8_STRING)
  (gui-get-selection value 'COMPOUND_TEXT)
  (gui-get-selection value 'STRING)
  (gui-get-selection value 'TEXT))

If the user (me) send any commands (C-p, C-n, M-x, ...) to emacs when it
is frozen, Emacs will stay frozen even after the 2s timeout.
Most of the time, it is possible to recover from the freeze by sending
SIGUSR2 to the emacs process.
The backtrace is :

Debugger entered--Lisp error: (quit)
  x-get-selection-internal(SECONDARY STRING nil nil)
  #f(compiled-function (selection-symbol target-type &optional time-stamp terminal) #<bytecode 0x564065>)(SECONDARY STRING)
  apply(#f(compiled-function (selection-symbol target-type &optional time-stamp terminal) #<bytecode 0x564065>) (SECONDARY STRING))
  gui-backend-get-selection(SECONDARY STRING)
  gui-get-selection(SECONDARY STRING)
  (let ((value 'SECONDARY) (x-selection-timeout 2000)) (gui-get-selection value 'UTF8_STRING) (gui-get-selection value 'COMPOUND_TEXT) (gui-get-selection value 'STRING) (gui-get-selection value 'TEXT))
  eval((let ((value 'SECONDARY) (x-selection-timeout 2000)) (gui-get-selection value 'UTF8_STRING) (gui-get-selection value 'COMPOUND_TEXT) (gui-get-selection value 'STRING) (gui-get-selection value 'TEXT)) nil)
  elisp--eval-last-sexp(nil)
  eval-last-sexp(nil)
  funcall-interactively(eval-last-sexp nil)
  call-interactively(eval-last-sexp nil nil)
  command-execute(eval-last-sexp)

I've done some experiments :
- Any *single* call of `gui-get-selection' will not freeze emacs for 2s.
- Any *combination of two* calls of `gui-get-selection' will freeze
  emacs for 2s but it will just stops if any command is sent (C-p, C-n,
  ...).
- Any *combination of three or four* calls of `gui-get-selection' will
  freeze emacs for 2s and freeze emacs completely if any command is sent
  (C-p, C-n, ...).
But I've no idea where to look to find out how to fix this problem.
Please, tell me how I can help.

I'm using Emacs 26.0.90 with Gtk3 on OpenBSD 6.2-current (GENERIC.MP).

Best,


In GNU Emacs 26.0.90 (build 1, x86_64-unknown-openbsd, GTK+ Version 3.22.24)
 of 2017-10-29 built on puffy
Repository revision: 6361151a84d643d4a5d658f740dac5809c682704
Windowing system distributor 'The X.Org Foundation', version 11.0.11804000

Configured using:
 'configure --build=amd64-unknown-openbsd --without-sound
 --with-x-toolkit=gtk3 --prefix=/usr/local --sysconfdir=/etc
 --mandir=/usr/local/man --infodir=/usr/local/info --localstatedir=/var
 --disable-silent-rules --disable-gtk-doc 'CFLAGS=-O2 -pipe -fno-pie'
 CPPFLAGS=-I/usr/local/include 'LDFLAGS=-L/usr/local/lib -nopie''

Configured features:
XPM JPEG TIFF GIF PNG RSVG IMAGEMAGICK DBUS GSETTINGS NOTIFY GNUTLS
LIBXML2 FREETYPE XFT ZLIB TOOLKIT_SCROLL_BARS GTK3 X11 LCMS2

Important settings:
  value of $LC_ALL: en_US.UTF-8
  value of $LC_COLLATE: en_US.UTF-8
  value of $LC_CTYPE: en_US.UTF-8
  value of $LC_MESSAGES: en_US.UTF-8
  value of $LC_MONETARY: en_US.UTF-8
  value of $LC_NUMERIC: en_US.UTF-8
  value of $LC_TIME: en_US.UTF-8
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix





Acknowledgement sent to daimrod@HIDDEN (Grégoire Jadi):
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#29170; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 5 Dec 2017 14:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.